import _classCallCheck from '@babel/runtime/helpers/esm/classCallCheck';
import _createClass from '@babel/runtime/helpers/esm/createClass';
import _get from '@babel/runtime/helpers/esm/get';
import _getPrototypeOf from '@babel/runtime/helpers/esm/getPrototypeOf';
import _inherits from '@babel/runtime/helpers/esm/inherits';
import _createSuper from '@babel/runtime/helpers/esm/createSuper';
import { isEngine, InlinePlugin } from '@aomao/engine';
import React, { useState, useRef, useEffect } from 'react';
import ReactDOM from 'react-dom';
import ConfigProvider from 'antd/lib/config-provider';
import _slicedToArray from '@babel/runtime/helpers/esm/slicedToArray';
import Input from 'antd/lib/input';
import Button from 'antd/lib/button';
import classnames from 'classnames-es-ts';
import 'antd/lib/input/style';
import 'antd/lib/button/style';
import Tooltip from 'antd/lib/tooltip';
import 'antd/lib/tooltip/style';

var LinkEditor = function LinkEditor(_ref) {
  var language = _ref.language,
      defaultLink = _ref.defaultLink,
      defaultText = _ref.defaultText,
      className = _ref.className,
      onLoad = _ref.onLoad,
      onOk = _ref.onOk;

  var _useState = useState(defaultText || ''),
      _useState2 = _slicedToArray(_useState, 2),
      text = _useState2[0],
      setText = _useState2[1];

  var _useState3 = useState(defaultLink || ''),
      _useState4 = _slicedToArray(_useState3, 2),
      link = _useState4[0],
      setLink = _useState4[1];

  var linkRef = useRef(null);
  useEffect(function () {
    var _linkRef$current;

    if (onLoad) onLoad();
    (_linkRef$current = linkRef.current) === null || _linkRef$current === void 0 ? void 0 : _linkRef$current.focus();
  }, []);
  return /*#__PURE__*/React.createElement("div", {
    className: classnames('data-link-editor', className)
  }, /*#__PURE__*/React.createElement("p", null, language.get('link', 'text')), /*#__PURE__*/React.createElement("p", null, /*#__PURE__*/React.createElement(Input, {
    className: "data-link-input",
    value: text,
    placeholder: language.get('link', 'text_placeholder').toString(),
    onChange: function onChange(event) {
      setText(event.target.value);
    }
  })), /*#__PURE__*/React.createElement("p", null, language.get('link', 'link')), /*#__PURE__*/React.createElement("p", null, /*#__PURE__*/React.createElement(Input, {
    ref: linkRef,
    className: "data-link-input",
    value: link,
    placeholder: language.get('link', 'link_placeholder').toString(),
    onChange: function onChange(event) {
      setLink(event.target.value);
    }
  })), /*#__PURE__*/React.createElement("p", null, /*#__PURE__*/React.createElement(Button, {
    className: "data-link-button",
    onClick: function onClick() {
      return onOk(text, link);
    },
    disabled: link.trim() === ''
  }, language.get('link', 'ok_button'))));
};

var LinkPreview = function LinkPreview(_ref) {
  var language = _ref.language,
      href = _ref.href,
      onEdit = _ref.onEdit,
      onRemove = _ref.onRemove;
  return /*#__PURE__*/React.createElement("div", {
    className: classnames('data-link-preview')
  }, /*#__PURE__*/React.createElement(Tooltip, {
    title: language.get('link', 'link_open')
  }, /*#__PURE__*/React.createElement("a", {
    className: "data-icon data-icon-link data-link-preview-open",
    href: href,
    target: "_blank"
  }, href)), /*#__PURE__*/React.createElement(Tooltip, {
    title: language.get('link', 'link_edit')
  }, /*#__PURE__*/React.createElement("a", {
    className: "data-icon data-icon-edit",
    onClick: onEdit
  })), /*#__PURE__*/React.createElement(Tooltip, {
    title: language.get('link', 'link_remove')
  }, /*#__PURE__*/React.createElement("a", {
    className: "data-icon data-icon-unlink",
    onClick: onRemove
  })));
};

var Toolbar = /*#__PURE__*/function () {
  function Toolbar(engine) {
    var _this = this;

    _classCallCheck(this, Toolbar);

    this.mouseInContainer = false;
    this.engine = engine;
    var _this$engine = this.engine,
        change = _this$engine.change,
        $ = _this$engine.$;
    change.event.onWindow('mousedown', function (event) {
      if (!event.target) return;
      var target = $(event.target);
      var container = target.closest('.data-link-container');
      _this.mouseInContainer = container && container.length > 0;
      if (!target.inEditor() && !_this.mouseInContainer) _this.hide();
    });
  }

  _createClass(Toolbar, [{
    key: "create",
    value: function create() {
      var _this$target$get;

      if (!this.target) return;
      var root = this.engine.$('.data-link-container');

      if (root.length === 0) {
        root = this.engine.$('<div class="data-link-container"></div>');
        document.body.appendChild(root[0]);
      }

      this.root = root;
      var rect = (_this$target$get = this.target.get()) === null || _this$target$get === void 0 ? void 0 : _this$target$get.getBoundingClientRect();
      if (!rect) return;
      this.root.css({
        top: "".concat(window.pageYOffset + rect.bottom + 4, "px"),
        left: "".concat(window.pageXOffset, "px"),
        position: 'absolute',
        'z-index': 1400
      });
    }
  }, {
    key: "update",
    value: function update() {
      var _this$target$get2, _this$root$get;

      if (!this.root || !this.target) return;
      var targetRect = (_this$target$get2 = this.target.get()) === null || _this$target$get2 === void 0 ? void 0 : _this$target$get2.getBoundingClientRect();
      if (!targetRect) return;
      var rootRect = (_this$root$get = this.root.get()) === null || _this$root$get === void 0 ? void 0 : _this$root$get.getBoundingClientRect();
      if (!rootRect) return;
      var top = targetRect.top,
          left = targetRect.left,
          bottom = targetRect.bottom;
      var height = rootRect.height,
          width = rootRect.width;
      var styleLeft = left + width > window.innerWidth - 20 ? window.pageXOffset + window.innerWidth - width - 20 : 20 > left - window.pageXOffset ? window.pageXOffset + 20 : window.pageXOffset + left;
      var styleTop = bottom + height > window.innerHeight - 20 ? window.pageYOffset + top - height - 4 : window.pageYOffset + bottom + 4;
      this.root.css({
        top: "".concat(styleTop, "px"),
        left: "".concat(styleLeft, "px")
      });
    }
  }, {
    key: "onOk",
    value: function onOk(text, link) {
      if (!this.target) return;
      var _this$engine2 = this.engine,
          change = _this$engine2.change,
          history = _this$engine2.history,
          inline = _this$engine2.inline;
      var range = change.getRange();

      if (!change.rangePathBeforeCommand) {
        if (!range.startNode.inEditor()) {
          range.select(this.target, true);
          change.select(range);
        }

        change.cacheRangeBeforeCommand();
      }

      this.target.attributes('href', link);
      text = text.trim() === '' ? link : text;
      this.target.text(text);
      this.engine.inline.repairCursor(this.target);
      range.setStart(this.target.next(), 1);
      range.setEnd(this.target.next(), 1);
      change.apply(range);
      history.submitCache();
      this.mouseInContainer = false;
      this.hide();
    }
  }, {
    key: "editor",
    value: function editor(text, href) {
      var _this2 = this;

      return /*#__PURE__*/React.createElement(LinkEditor, {
        language: this.engine.language,
        defaultText: text,
        defaultLink: href,
        onLoad: function onLoad() {
          return _this2.mouseInContainer = true;
        },
        onOk: function onOk(text, link) {
          return _this2.onOk(text, link);
        }
      });
    }
  }, {
    key: "preview",
    value: function preview(href) {
      var _this3 = this;

      return /*#__PURE__*/React.createElement(LinkPreview, {
        language: this.engine.language,
        onEdit: function onEdit() {
          if (!_this3.target) return;
          _this3.mouseInContainer = false;

          _this3.hide(undefined, false);

          _this3.show(_this3.target, true);
        },
        onRemove: function onRemove() {
          if (!_this3.target) return;
          var _this3$engine = _this3.engine,
              change = _this3$engine.change,
              inline = _this3$engine.inline;
          var range = change.getRange();
          range.select(_this3.target, true);
          inline.repairRange(range);
          change.select(range);
          change.cacheRangeBeforeCommand();
          inline.unwrap();
          _this3.mouseInContainer = false;
          _this3.target = undefined;

          _this3.hide();
        },
        href: href
      });
    }
  }, {
    key: "show",
    value: function show(target, forceEdit) {
      var _this4 = this;

      this.target = target;
      this.create();
      var text = target.text().replace(/\u200B/g, '');
      var href = target.attributes('href');
      var container = this.root.get();
      ReactDOM.render( /*#__PURE__*/React.createElement(ConfigProvider, {
        autoInsertSpaceInButton: false
      }, !href || forceEdit ? this.editor(text, href) : this.preview(href)), container, function () {
        _this4.update();
      });
    }
  }, {
    key: "hide",
    value: function hide(target, clearTarget) {
      var _this$root;

      if (target && this.target && target.equal(this.target)) return;
      var elment = (_this$root = this.root) === null || _this$root === void 0 ? void 0 : _this$root.get();

      if (elment && !this.mouseInContainer) {
        ReactDOM.unmountComponentAtNode(elment);
        document.body.removeChild(elment);
        this.root = undefined;

        if (this.target && !this.target.attributes('href')) {
          var _this$engine3 = this.engine,
              change = _this$engine3.change,
              inline = _this$engine3.inline;
          var range = change.getRange();
          range.select(this.target, true);
          change.select(range);
          inline.unwrap();
          this.engine.history.destroyCache();
        }

        if (clearTarget !== false) this.target = undefined;
      }
    }
  }]);

  return Toolbar;
}();

var en = {
  link: {
    text: 'Text',
    link: 'Link',
    text_placeholder: 'Description text',
    link_placeholder: 'Link address',
    link_open: 'Open link',
    link_edit: 'Edit link',
    link_remove: 'Remove link',
    ok_button: 'OK'
  }
};

var cn = {
  link: {
    text: '文本',
    link: '链接',
    text_placeholder: '描述文本',
    link_placeholder: '链接地址',
    link_open: '打开链接',
    link_edit: '编辑链接',
    link_remove: '移除链接',
    ok_button: '确定'
  }
};

var locales = {
  en: en,
  'zh-cn': cn
};

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = ".data-link-container {\n    max-width: 398px;\n    display: inline-block;\n    border: 1px solid #E8E8E8;\n    border-radius: 4px;\n    box-shadow: rgba(221, 221, 221, 0.5) 0px 1px 3px;\n    background: white;\n}\n\n.data-link-container .data-link-editor {\n    width: 365px;\n    padding: 16px 12px;\n    padding-bottom: 4px;\n}\n\n.data-link-container p {\n    margin-top: 0;\n    margin-bottom: 14px;\n}\n\n.data-link-container .itellyou-icon {\n    color: #8590A6;\n    font-size: 16px;\n}\n.data-link-preview {\n    line-height: 16px;\n    padding: 6px 8px;\n    vertical-align: middle;\n    white-space: nowrap;\n}\n.data-link-preview * {\n    display: inline-block;\n}\n.data-link-preview a {\n    color: #595959;\n    margin: 0px 0px 0px 8px;\n    padding: 4px;\n}\n.data-link-preview a:hover {\n    background: #F4F4F4;\n    cursor: pointer;\n}\n.data-link-preview a.data-link-preview-open {\n    color: #1890FF;\n    max-width: 292px;\n    overflow: hidden;\n    text-overflow: ellipsis;\n    white-space: nowrap;\n    text-decoration: none;\n    font-size: 14px;\n    letter-spacing: 1.2px;\n    vertical-align: middle;\n    margin: 0;\n}\n.data-link-preview a.data-link-preview-open::before\n{\n    vertical-align: middle;\n    margin-right: 2px;\n}\n\n.data-link-preview a.data-link-preview-open:hover{\n    background: transparent;\n}";
styleInject(css_248z);

var _default = /*#__PURE__*/function (_InlinePlugin) {
  _inherits(_default, _InlinePlugin);

  var _super = _createSuper(_default);

  function _default() {
    var _this;

    _classCallCheck(this, _default);

    _this = _super.apply(this, arguments);
    _this.attributes = {
      target: '@var0',
      href: '@var1'
    };
    _this.variable = {
      '@var0': ['_blank', '_parent', '_top', '_self'],
      '@var1': '*'
    };
    _this.tagName = 'a';
    _this.markdown = _this.options.markdown !== false ? '\\[(.+?)\\]\\(([\\S]+?)\\)$' : '';
    return _this;
  }

  _createClass(_default, [{
    key: "init",
    value: function init() {
      var _this2 = this;

      _get(_getPrototypeOf(_default.prototype), "init", this).call(this);

      if (isEngine(this.editor)) {
        this.toolbar = new Toolbar(this.editor);
      }

      this.editor.on('paser:html', function (node) {
        return _this2.parseHtml(node);
      });
      this.editor.language.add(locales);
    }
  }, {
    key: "hotkey",
    value: function hotkey() {
      return this.options.hotkey || {
        key: 'mod+k',
        args: ['_blank']
      };
    }
  }, {
    key: "execute",
    value: function execute() {
      if (!isEngine(this.editor)) return;
      var inline = this.editor.inline;

      if (!this.queryState()) {
        var inlineNode = this.editor.$("<".concat(this.tagName, " />"));
        this.setStyle.apply(this, [inlineNode].concat(Array.prototype.slice.call(arguments)));
        this.setAttributes.apply(this, [inlineNode].concat(Array.prototype.slice.call(arguments)));
        var text = arguments.length > 2 ? arguments[2] : '';

        if (!!text) {
          inlineNode.text(text);
          inline.insert(inlineNode);
        } else {
          this.editor.history.startCache();
          inline.wrap(inlineNode);
        }

        var change = this.editor.change;
        var range = change.getRange();

        if (!range.collapsed && change.inlines.length > 0) {
          var _this$toolbar;

          (_this$toolbar = this.toolbar) === null || _this$toolbar === void 0 ? void 0 : _this$toolbar.show(change.inlines[0]);
        }
      }
    }
  }, {
    key: "queryState",
    value: function queryState() {
      var _this3 = this,
          _this$toolbar2;

      if (!isEngine(this.editor)) return;
      var change = this.editor.change;
      var inlineNode = change.inlines.find(function (node) {
        return _this3.isSelf(node);
      });
      (_this$toolbar2 = this.toolbar) === null || _this$toolbar2 === void 0 ? void 0 : _this$toolbar2.hide(inlineNode);

      if (inlineNode) {
        var _this$toolbar3;

        if (change.getRange().collapsed) (_this$toolbar3 = this.toolbar) === null || _this$toolbar3 === void 0 ? void 0 : _this$toolbar3.show(inlineNode);
        return true;
      }

      return false;
    }
  }, {
    key: "triggerMarkdown",
    value: function triggerMarkdown(event, text, node) {
      if (!isEngine(this.editor) || !this.markdown) return;
      var match = new RegExp(this.markdown).exec(text);

      if (match) {
        var _this$editor = this.editor,
            $ = _this$editor.$,
            command = _this$editor.command;
        event.preventDefault();
        var _text = match[1];
        var url = match[2]; // 移除 markdown 语法

        var markdownTextNode = node.get().splitText(node.text().length - match[0].length);
        markdownTextNode.splitText(match[0].length);
        $(markdownTextNode).remove();
        command.execute(this.constructor.pluginName, '_blank', url, _text);
        this.editor.node.insertText('\xA0');
        return false;
      }

      return;
    }
  }, {
    key: "pasteMarkdown",
    value: function pasteMarkdown(node) {
      if (!isEngine(this.editor) || !this.markdown || !node.isText()) return;
      var text = node.text();
      if (!text) return;
      var reg = /([^!]\[(.+?)\]\(([\S]+?)\))/;
      var match = reg.exec(text);
      if (!match) return;
      var newText = '';
      var textNode = node.clone(true).get();

      while (textNode.textContent && (match = reg.exec(textNode.textContent))) {
        var _inlineNode$get;

        //从匹配到的位置切断
        var regNode = textNode.splitText(match.index + 1);
        newText += textNode.textContent; //从匹配结束位置分割

        textNode = regNode.splitText(match[0].length - 1);
        var _text2 = match[2];
        var url = match[3];
        var inlineNode = this.editor.$("<".concat(this.tagName, " />"));
        this.setAttributes(inlineNode, '_blank', url);
        inlineNode.text(!!_text2 ? _text2 : url);
        newText += (_inlineNode$get = inlineNode.get()) === null || _inlineNode$get === void 0 ? void 0 : _inlineNode$get.outerHTML;
      }

      newText += textNode.textContent;
      node.text(newText);
    }
  }, {
    key: "parseHtml",
    value: function parseHtml(root) {
      root.find(this.tagName).css({
        'font-family': 'monospace',
        'font-size': 'inherit',
        'background-color': 'rgba(0,0,0,.06)',
        padding: '0 2px',
        border: '1px solid rgba(0,0,0,.08)',
        'border-radius': '2px 2px',
        'line-height': 'inherit',
        'overflow-wrap': 'break-word',
        'text-indent': '0'
      });
    }
  }], [{
    key: "pluginName",
    get: function get() {
      return 'link';
    }
  }]);

  return _default;
}(InlinePlugin);

export default _default;
