'use strict';

var engine = require('@aomao/engine');
var React = require('react');
var ReactDOM = require('react-dom');
var ConfigProvider = require('antd/lib/config-provider');
var Input = require('antd/lib/input');
var Button = require('antd/lib/button');
var classnames = require('classnames-es-ts');
require('antd/lib/input/style');
require('antd/lib/button/style');
var Tooltip = require('antd/lib/tooltip');
require('antd/lib/tooltip/style');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var ReactDOM__default = /*#__PURE__*/_interopDefaultLegacy(ReactDOM);
var ConfigProvider__default = /*#__PURE__*/_interopDefaultLegacy(ConfigProvider);
var Input__default = /*#__PURE__*/_interopDefaultLegacy(Input);
var Button__default = /*#__PURE__*/_interopDefaultLegacy(Button);
var classnames__default = /*#__PURE__*/_interopDefaultLegacy(classnames);
var Tooltip__default = /*#__PURE__*/_interopDefaultLegacy(Tooltip);

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();

  return function _createSuperInternal() {
    var Super = _getPrototypeOf(Derived),
        result;

    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _superPropBase(object, property) {
  while (!Object.prototype.hasOwnProperty.call(object, property)) {
    object = _getPrototypeOf(object);
    if (object === null) break;
  }

  return object;
}

function _get(target, property, receiver) {
  if (typeof Reflect !== "undefined" && Reflect.get) {
    _get = Reflect.get;
  } else {
    _get = function _get(target, property, receiver) {
      var base = _superPropBase(target, property);

      if (!base) return;
      var desc = Object.getOwnPropertyDescriptor(base, property);

      if (desc.get) {
        return desc.get.call(receiver);
      }

      return desc.value;
    };
  }

  return _get(target, property, receiver || target);
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var LinkEditor = function LinkEditor(_ref) {
  var language = _ref.language,
      defaultLink = _ref.defaultLink,
      defaultText = _ref.defaultText,
      className = _ref.className,
      onLoad = _ref.onLoad,
      onOk = _ref.onOk;

  var _useState = React.useState(defaultText || ''),
      _useState2 = _slicedToArray(_useState, 2),
      text = _useState2[0],
      setText = _useState2[1];

  var _useState3 = React.useState(defaultLink || ''),
      _useState4 = _slicedToArray(_useState3, 2),
      link = _useState4[0],
      setLink = _useState4[1];

  var linkRef = React.useRef(null);
  React.useEffect(function () {
    var _linkRef$current;

    if (onLoad) onLoad();
    (_linkRef$current = linkRef.current) === null || _linkRef$current === void 0 ? void 0 : _linkRef$current.focus();
  }, []);
  return /*#__PURE__*/React__default['default'].createElement("div", {
    className: classnames__default['default']('data-link-editor', className)
  }, /*#__PURE__*/React__default['default'].createElement("p", null, language.get('link', 'text')), /*#__PURE__*/React__default['default'].createElement("p", null, /*#__PURE__*/React__default['default'].createElement(Input__default['default'], {
    className: "data-link-input",
    value: text,
    placeholder: language.get('link', 'text_placeholder').toString(),
    onChange: function onChange(event) {
      setText(event.target.value);
    }
  })), /*#__PURE__*/React__default['default'].createElement("p", null, language.get('link', 'link')), /*#__PURE__*/React__default['default'].createElement("p", null, /*#__PURE__*/React__default['default'].createElement(Input__default['default'], {
    ref: linkRef,
    className: "data-link-input",
    value: link,
    placeholder: language.get('link', 'link_placeholder').toString(),
    onChange: function onChange(event) {
      setLink(event.target.value);
    }
  })), /*#__PURE__*/React__default['default'].createElement("p", null, /*#__PURE__*/React__default['default'].createElement(Button__default['default'], {
    className: "data-link-button",
    onClick: function onClick() {
      return onOk(text, link);
    },
    disabled: link.trim() === ''
  }, language.get('link', 'ok_button'))));
};

var LinkPreview = function LinkPreview(_ref) {
  var language = _ref.language,
      href = _ref.href,
      onEdit = _ref.onEdit,
      onRemove = _ref.onRemove;
  return /*#__PURE__*/React__default['default'].createElement("div", {
    className: classnames__default['default']('data-link-preview')
  }, /*#__PURE__*/React__default['default'].createElement(Tooltip__default['default'], {
    title: language.get('link', 'link_open')
  }, /*#__PURE__*/React__default['default'].createElement("a", {
    className: "data-icon data-icon-link data-link-preview-open",
    href: href,
    target: "_blank"
  }, href)), /*#__PURE__*/React__default['default'].createElement(Tooltip__default['default'], {
    title: language.get('link', 'link_edit')
  }, /*#__PURE__*/React__default['default'].createElement("a", {
    className: "data-icon data-icon-edit",
    onClick: onEdit
  })), /*#__PURE__*/React__default['default'].createElement(Tooltip__default['default'], {
    title: language.get('link', 'link_remove')
  }, /*#__PURE__*/React__default['default'].createElement("a", {
    className: "data-icon data-icon-unlink",
    onClick: onRemove
  })));
};

var Toolbar = /*#__PURE__*/function () {
  function Toolbar(engine) {
    var _this = this;

    _classCallCheck(this, Toolbar);

    this.mouseInContainer = false;
    this.engine = engine;
    var _this$engine = this.engine,
        change = _this$engine.change,
        $ = _this$engine.$;
    change.event.onWindow('mousedown', function (event) {
      if (!event.target) return;
      var target = $(event.target);
      var container = target.closest('.data-link-container');
      _this.mouseInContainer = container && container.length > 0;
      if (!target.inEditor() && !_this.mouseInContainer) _this.hide();
    });
  }

  _createClass(Toolbar, [{
    key: "create",
    value: function create() {
      var _this$target$get;

      if (!this.target) return;
      var root = this.engine.$('.data-link-container');

      if (root.length === 0) {
        root = this.engine.$('<div class="data-link-container"></div>');
        document.body.appendChild(root[0]);
      }

      this.root = root;
      var rect = (_this$target$get = this.target.get()) === null || _this$target$get === void 0 ? void 0 : _this$target$get.getBoundingClientRect();
      if (!rect) return;
      this.root.css({
        top: "".concat(window.pageYOffset + rect.bottom + 4, "px"),
        left: "".concat(window.pageXOffset, "px"),
        position: 'absolute',
        'z-index': 1400
      });
    }
  }, {
    key: "update",
    value: function update() {
      var _this$target$get2, _this$root$get;

      if (!this.root || !this.target) return;
      var targetRect = (_this$target$get2 = this.target.get()) === null || _this$target$get2 === void 0 ? void 0 : _this$target$get2.getBoundingClientRect();
      if (!targetRect) return;
      var rootRect = (_this$root$get = this.root.get()) === null || _this$root$get === void 0 ? void 0 : _this$root$get.getBoundingClientRect();
      if (!rootRect) return;
      var top = targetRect.top,
          left = targetRect.left,
          bottom = targetRect.bottom;
      var height = rootRect.height,
          width = rootRect.width;
      var styleLeft = left + width > window.innerWidth - 20 ? window.pageXOffset + window.innerWidth - width - 20 : 20 > left - window.pageXOffset ? window.pageXOffset + 20 : window.pageXOffset + left;
      var styleTop = bottom + height > window.innerHeight - 20 ? window.pageYOffset + top - height - 4 : window.pageYOffset + bottom + 4;
      this.root.css({
        top: "".concat(styleTop, "px"),
        left: "".concat(styleLeft, "px")
      });
    }
  }, {
    key: "onOk",
    value: function onOk(text, link) {
      if (!this.target) return;
      var _this$engine2 = this.engine,
          change = _this$engine2.change,
          history = _this$engine2.history,
          inline = _this$engine2.inline;
      var range = change.getRange();

      if (!change.rangePathBeforeCommand) {
        if (!range.startNode.inEditor()) {
          range.select(this.target, true);
          change.select(range);
        }

        change.cacheRangeBeforeCommand();
      }

      this.target.attributes('href', link);
      text = text.trim() === '' ? link : text;
      this.target.text(text);
      this.engine.inline.repairCursor(this.target);
      range.setStart(this.target.next(), 1);
      range.setEnd(this.target.next(), 1);
      change.apply(range);
      history.submitCache();
      this.mouseInContainer = false;
      this.hide();
    }
  }, {
    key: "editor",
    value: function editor(text, href) {
      var _this2 = this;

      return /*#__PURE__*/React__default['default'].createElement(LinkEditor, {
        language: this.engine.language,
        defaultText: text,
        defaultLink: href,
        onLoad: function onLoad() {
          return _this2.mouseInContainer = true;
        },
        onOk: function onOk(text, link) {
          return _this2.onOk(text, link);
        }
      });
    }
  }, {
    key: "preview",
    value: function preview(href) {
      var _this3 = this;

      return /*#__PURE__*/React__default['default'].createElement(LinkPreview, {
        language: this.engine.language,
        onEdit: function onEdit() {
          if (!_this3.target) return;
          _this3.mouseInContainer = false;

          _this3.hide(undefined, false);

          _this3.show(_this3.target, true);
        },
        onRemove: function onRemove() {
          if (!_this3.target) return;
          var _this3$engine = _this3.engine,
              change = _this3$engine.change,
              inline = _this3$engine.inline;
          var range = change.getRange();
          range.select(_this3.target, true);
          inline.repairRange(range);
          change.select(range);
          change.cacheRangeBeforeCommand();
          inline.unwrap();
          _this3.mouseInContainer = false;
          _this3.target = undefined;

          _this3.hide();
        },
        href: href
      });
    }
  }, {
    key: "show",
    value: function show(target, forceEdit) {
      var _this4 = this;

      this.target = target;
      this.create();
      var text = target.text().replace(/\u200B/g, '');
      var href = target.attributes('href');
      var container = this.root.get();
      ReactDOM__default['default'].render( /*#__PURE__*/React__default['default'].createElement(ConfigProvider__default['default'], {
        autoInsertSpaceInButton: false
      }, !href || forceEdit ? this.editor(text, href) : this.preview(href)), container, function () {
        _this4.update();
      });
    }
  }, {
    key: "hide",
    value: function hide(target, clearTarget) {
      var _this$root;

      if (target && this.target && target.equal(this.target)) return;
      var elment = (_this$root = this.root) === null || _this$root === void 0 ? void 0 : _this$root.get();

      if (elment && !this.mouseInContainer) {
        ReactDOM__default['default'].unmountComponentAtNode(elment);
        document.body.removeChild(elment);
        this.root = undefined;

        if (this.target && !this.target.attributes('href')) {
          var _this$engine3 = this.engine,
              change = _this$engine3.change,
              inline = _this$engine3.inline;
          var range = change.getRange();
          range.select(this.target, true);
          change.select(range);
          inline.unwrap();
          this.engine.history.destroyCache();
        }

        if (clearTarget !== false) this.target = undefined;
      }
    }
  }]);

  return Toolbar;
}();

var en = {
  link: {
    text: 'Text',
    link: 'Link',
    text_placeholder: 'Description text',
    link_placeholder: 'Link address',
    link_open: 'Open link',
    link_edit: 'Edit link',
    link_remove: 'Remove link',
    ok_button: 'OK'
  }
};

var cn = {
  link: {
    text: '文本',
    link: '链接',
    text_placeholder: '描述文本',
    link_placeholder: '链接地址',
    link_open: '打开链接',
    link_edit: '编辑链接',
    link_remove: '移除链接',
    ok_button: '确定'
  }
};

var locales = {
  en: en,
  'zh-cn': cn
};

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = ".data-link-container {\n    max-width: 398px;\n    display: inline-block;\n    border: 1px solid #E8E8E8;\n    border-radius: 4px;\n    box-shadow: rgba(221, 221, 221, 0.5) 0px 1px 3px;\n    background: white;\n}\n\n.data-link-container .data-link-editor {\n    width: 365px;\n    padding: 16px 12px;\n    padding-bottom: 4px;\n}\n\n.data-link-container p {\n    margin-top: 0;\n    margin-bottom: 14px;\n}\n\n.data-link-container .itellyou-icon {\n    color: #8590A6;\n    font-size: 16px;\n}\n.data-link-preview {\n    line-height: 16px;\n    padding: 6px 8px;\n    vertical-align: middle;\n    white-space: nowrap;\n}\n.data-link-preview * {\n    display: inline-block;\n}\n.data-link-preview a {\n    color: #595959;\n    margin: 0px 0px 0px 8px;\n    padding: 4px;\n}\n.data-link-preview a:hover {\n    background: #F4F4F4;\n    cursor: pointer;\n}\n.data-link-preview a.data-link-preview-open {\n    color: #1890FF;\n    max-width: 292px;\n    overflow: hidden;\n    text-overflow: ellipsis;\n    white-space: nowrap;\n    text-decoration: none;\n    font-size: 14px;\n    letter-spacing: 1.2px;\n    vertical-align: middle;\n    margin: 0;\n}\n.data-link-preview a.data-link-preview-open::before\n{\n    vertical-align: middle;\n    margin-right: 2px;\n}\n\n.data-link-preview a.data-link-preview-open:hover{\n    background: transparent;\n}";
styleInject(css_248z);

var _default = /*#__PURE__*/function (_InlinePlugin) {
  _inherits(_default, _InlinePlugin);

  var _super = _createSuper(_default);

  function _default() {
    var _this;

    _classCallCheck(this, _default);

    _this = _super.apply(this, arguments);
    _this.attributes = {
      target: '@var0',
      href: '@var1'
    };
    _this.variable = {
      '@var0': ['_blank', '_parent', '_top', '_self'],
      '@var1': '*'
    };
    _this.tagName = 'a';
    _this.markdown = _this.options.markdown !== false ? '\\[(.+?)\\]\\(([\\S]+?)\\)$' : '';
    return _this;
  }

  _createClass(_default, [{
    key: "init",
    value: function init() {
      var _this2 = this;

      _get(_getPrototypeOf(_default.prototype), "init", this).call(this);

      if (engine.isEngine(this.editor)) {
        this.toolbar = new Toolbar(this.editor);
      }

      this.editor.on('paser:html', function (node) {
        return _this2.parseHtml(node);
      });
      this.editor.language.add(locales);
    }
  }, {
    key: "hotkey",
    value: function hotkey() {
      return this.options.hotkey || {
        key: 'mod+k',
        args: ['_blank']
      };
    }
  }, {
    key: "execute",
    value: function execute() {
      if (!engine.isEngine(this.editor)) return;
      var inline = this.editor.inline;

      if (!this.queryState()) {
        var inlineNode = this.editor.$("<".concat(this.tagName, " />"));
        this.setStyle.apply(this, [inlineNode].concat(Array.prototype.slice.call(arguments)));
        this.setAttributes.apply(this, [inlineNode].concat(Array.prototype.slice.call(arguments)));
        var text = arguments.length > 2 ? arguments[2] : '';

        if (!!text) {
          inlineNode.text(text);
          inline.insert(inlineNode);
        } else {
          this.editor.history.startCache();
          inline.wrap(inlineNode);
        }

        var change = this.editor.change;
        var range = change.getRange();

        if (!range.collapsed && change.inlines.length > 0) {
          var _this$toolbar;

          (_this$toolbar = this.toolbar) === null || _this$toolbar === void 0 ? void 0 : _this$toolbar.show(change.inlines[0]);
        }
      }
    }
  }, {
    key: "queryState",
    value: function queryState() {
      var _this3 = this,
          _this$toolbar2;

      if (!engine.isEngine(this.editor)) return;
      var change = this.editor.change;
      var inlineNode = change.inlines.find(function (node) {
        return _this3.isSelf(node);
      });
      (_this$toolbar2 = this.toolbar) === null || _this$toolbar2 === void 0 ? void 0 : _this$toolbar2.hide(inlineNode);

      if (inlineNode) {
        var _this$toolbar3;

        if (change.getRange().collapsed) (_this$toolbar3 = this.toolbar) === null || _this$toolbar3 === void 0 ? void 0 : _this$toolbar3.show(inlineNode);
        return true;
      }

      return false;
    }
  }, {
    key: "triggerMarkdown",
    value: function triggerMarkdown(event, text, node) {
      if (!engine.isEngine(this.editor) || !this.markdown) return;
      var match = new RegExp(this.markdown).exec(text);

      if (match) {
        var _this$editor = this.editor,
            $ = _this$editor.$,
            command = _this$editor.command;
        event.preventDefault();
        var _text = match[1];
        var url = match[2]; // 移除 markdown 语法

        var markdownTextNode = node.get().splitText(node.text().length - match[0].length);
        markdownTextNode.splitText(match[0].length);
        $(markdownTextNode).remove();
        command.execute(this.constructor.pluginName, '_blank', url, _text);
        this.editor.node.insertText('\xA0');
        return false;
      }

      return;
    }
  }, {
    key: "pasteMarkdown",
    value: function pasteMarkdown(node) {
      if (!engine.isEngine(this.editor) || !this.markdown || !node.isText()) return;
      var text = node.text();
      if (!text) return;
      var reg = /([^!]\[(.+?)\]\(([\S]+?)\))/;
      var match = reg.exec(text);
      if (!match) return;
      var newText = '';
      var textNode = node.clone(true).get();

      while (textNode.textContent && (match = reg.exec(textNode.textContent))) {
        var _inlineNode$get;

        //从匹配到的位置切断
        var regNode = textNode.splitText(match.index + 1);
        newText += textNode.textContent; //从匹配结束位置分割

        textNode = regNode.splitText(match[0].length - 1);
        var _text2 = match[2];
        var url = match[3];
        var inlineNode = this.editor.$("<".concat(this.tagName, " />"));
        this.setAttributes(inlineNode, '_blank', url);
        inlineNode.text(!!_text2 ? _text2 : url);
        newText += (_inlineNode$get = inlineNode.get()) === null || _inlineNode$get === void 0 ? void 0 : _inlineNode$get.outerHTML;
      }

      newText += textNode.textContent;
      node.text(newText);
    }
  }, {
    key: "parseHtml",
    value: function parseHtml(root) {
      root.find(this.tagName).css({
        'font-family': 'monospace',
        'font-size': 'inherit',
        'background-color': 'rgba(0,0,0,.06)',
        padding: '0 2px',
        border: '1px solid rgba(0,0,0,.08)',
        'border-radius': '2px 2px',
        'line-height': 'inherit',
        'overflow-wrap': 'break-word',
        'text-indent': '0'
      });
    }
  }], [{
    key: "pluginName",
    get: function get() {
      return 'link';
    }
  }]);

  return _default;
}(engine.InlinePlugin);

module.exports = _default;
